<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getClient } from '../../plugins/contentful.js';
import { CONTENT_TYPES } from '../../common/content-types';
import { NextStepAlt } from '../../components/common/index.vue';
import { PreferencesForm } from '../../components/company/index.vue';
import { getPageMetadata } from '../../common/meta';
import { SolutionsHero as Hero } from '../../components/solutions/index.vue';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { FooterEditLinkMixin } from '~/mixins';

export default Vue.extend({
  name: 'Company',
  components: {
    NextStepAlt,
    Hero,
    PreferencesForm,
  },
  mixins: [FooterEditLinkMixin],
  nuxtI18n: {
    locales: ['de-de', 'fr-fr', 'ja-jp', 'en-us'],
  },
  async asyncData({ i18n }) {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '5Oi2Yb3SoiLjhLXOW1u96Q',
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;
      const data = items[0].fields.pageContent;

      const [cmsHero, cmsPreferencesForm] = data;

      const hero = {
        data: {
          title: cmsHero.fields.title,
          subtitle: cmsHero.fields.description,
          image: {
            image_url: cmsHero.fields.backgroundImage.fields.file.url,
            bordered: true,
            rectangular: true,
          },
        },
        name: 'hero',
      };

      const preferencesForm = {
        data: {
          formId: cmsPreferencesForm.fields.formId,
          datalayer: 'preference center',
          form_header: '',
          form_paragraph: '',
          required_text: ' ',
          all_required: false,
          submitted_message: {
            header: cmsPreferencesForm?.fields?.confirmationMessage,
            body: cmsPreferencesForm?.fields?.blurb,
          },
        },
        name: 'preferences-form',
      };

      const preferenceCenter = {
        title: items[0].fields.seoMetadata[0].fields.title,
        description: items[0].fields.seoMetadata[0].fields.description,
        components: [hero, preferencesForm],
      };

      return { preferenceCenter, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).preferenceCenter,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div>
    <SlpColumn>
      <component
        :is="component.name"
        v-for="(component, i) in preferenceCenter.components"
        :key="i"
        :data="component.data"
      />
    </SlpColumn>
    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
// marketo specific overrides
:deep(.mktoForm_container .mktoFieldWrap label) {
  margin-bottom: 16px;
}
</style>
